import sys

# This program converts from a pixelscape format to the format needed here.
def conv():
    if len(sys.argv) != 2:
        return
    f = open(sys.argv[1],'r')
    l = f.read().strip().split('\n')
    f.close()

    tiles = []
    map = []
    w = int(l[-1].split(' ')[-1])
    read = False
    for i in l:
        read |= (i == "map:")
        if read and i.startswith('.db '):
            map += i[4:].split(',')

    # get all of the tiles used
    for i in map:
        i = int(i)
        if i not in tiles:
            tiles.append(i)
    tiles = sorted(tiles)

    h = int(len(map) / w)
    s = '.db ' + str(h) + ',' + str(w)
    s += '\n.db 0,0'
    s += '\n.db ' +str(len(tiles))
    for i in tiles:
        s += '\n.dw '+str(i)

    walking = [0,9,14,15,16,17,39,50,54]
    for i in range(h):
        k = i
        s += '\n.db '
        while k<len(map):
            j = int(map[k])
            if j not in walking:
                t = hex(128+tiles.index(j))[2:]
            else:
                t = hex(tiles.index(j))[2:]
            s += '$'+'0'*(2-len(t))+t+','
            k += w
    s +='\n.db 0'
    s = s.replace(',\n','\n')
    print(s)
    return

conv()
